/*****************************************************************************
*   $Id: dgmeth.c,v 1.1.1.1 2000/06/22 15:38:49 tekno Exp $
*
*    Copyright (C) 2000, Stephen J. Hardy
*
*    techno@spirit.net.au
*    16 Powers Place, Latham, A.C.T. 2615, Australia
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
* $Log: dgmeth.c,v $
* Revision 1.1.1.1  2000/06/22 15:38:49  tekno
* Opened source
*
*
*****************************************************************************/
/* dgmeth.c - stuff to do with user-defined methods */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include "dglex.h"
#include "dgvar.h"
#include "dgdb.h"
#include "y.tab.h"

static hash_table func_tab;

int grok_mdef(tree md)
{
  method_info * mi;

  mi = (method_info *)calloc(sizeof(*mi), 1);
  mi->func = md;
  mi->name = mi->func->u.mdef.name;
  /*fprintf(stderr, "method name = %s\n", mi->name);*/
  if (lookup_hash(&func_tab, mi->name))
  {
    error(mi->func, "Method already defined");
    return 6;
  }
  ADD_HASH(&func_tab, mi);
  return 0;
}

int grok_mdefs(list root)
{
  int rc;
  
  /* Preprocess any method definitions.  This involves setting up a hash
     table of method names for rapid lookup */
  init_ht(&func_tab, 67, offsetof(method_info, name));
  while (root)
  {
    if (root->val->type == T_FUNCTION)
    {
      rc = grok_mdef(root->val);
      if (rc)
        return rc;
    }
    root = root->next;
  }
  return 0;
}

method_info * get_usermethod(char * mn)
{
  method_info * mi = (method_info *)lookup_hash(&func_tab, mn);
  return mi;
}
