/*****************************************************************************
*   $Id: dgmethods.h,v 1.1.1.1 2000/06/22 15:38:54 tekno Exp $
*
*    Copyright (C) 2000, Stephen J. Hardy
*
*    techno@spirit.net.au
*    16 Powers Place, Latham, A.C.T. 2615, Australia
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
* $Log: dgmethods.h,v $
* Revision 1.1.1.1  2000/06/22 15:38:54  tekno
* Opened source
*
*
*****************************************************************************/
/* methods table */

DG_METHOD(M_LENGTH, E_STRING, E_INT, 
          int, m_length, (char * s), 
          0, "length", "length of string")

DG_METHOD(M_SUBSTR, E_STRING, E_STRING,
          char *, m_substr, (char * s, list p),
          2, "substr", "substring of string(start 0..., length)")

DG_METHOD(M_CONTENTS, E_STRING, E_STRING,
          char *, m_contents, (char * s, list p),
          0, "contents", "contents of file")

DG_METHOD(M_RUN, E_STRING, E_STRING,
          char *, m_run, (char * s, list p),
          0, "run", "stdout of external command")

DG_METHOD(M_ENV, E_STRING, E_STRING,
          char *, m_env, (char * s, list p),
          0, "env", "value of environment variable")

DG_METHOD(M_INT, E_STRING, E_INT,
          int, m_int, (char * s),
          0, "int", "decimal string converted to integer")

DG_METHOD(M_HEXINT, E_STRING, E_INT,
          int, m_hexint, (char * s),
          0, "hexint", "hexadecimal string converted to integer")

DG_METHOD(M_INTHEX, E_INT, E_STRING,
          char *, m_inthex, (int v, list p),
          0, "inthex", "integer converted to hexadecimal string (prec)")

DG_METHOD(M_CHAR, E_STRING, E_INT,
          int, m_char, (char * s),
          0, "char", "1st char of string converted to character value")

DG_METHOD(M_ISCTRL, E_STRING, E_INT,
          int, m_isctrl, (char * s),
          0, "is_ctrl", "Test if string start with control character")

DG_METHOD(M_ISINT, E_STRING, E_INT,
          int, m_isint, (char * s),
          0, "is_int", "Test if string is a decimal integer")

DG_METHOD(M_ISHEXINT, E_STRING, E_INT,
          int, m_ishexint, (char * s),
          0, "is_hexint", "Test if string is a hexadecimal integer")

DG_METHOD(M_IS_FIRST, E_VAR, E_INT,
          int, m_is_first, (var * v),
          0, "is_first", "True if first iteration of variable")

DG_METHOD(M_IS_LAST, E_VAR, E_INT,
          int, m_is_last, (var * v),
          0, "is_last", "True if last iteration of variable")

DG_METHOD(M_SLICE, E_STRING, E_INT,
          int, m_slice, (char * s, list p),
          0, "slice", "Slice string delimited by regexp (rx,var)")

DG_METHOD(M_MATCH, E_VAR, E_STRING,
          char *, m_match, (var * v, list p),
          0, "match", "Matching segment of slice var (match index)")

DG_METHOD(M_NOT_MATCH, E_VAR, E_STRING,
          char *, m_not_match, (var * v, list p),
          0, "not_match", "Non-matching segment of slice var (match index)")

DG_METHOD(M_UNSLICE, E_VAR, E_STRING,
          char *, m_unslice, (var * v, list p),
          0, "unslice", "Join parts of slice var back together")

DG_METHOD(M_TOUPPER, E_STRING, E_STRING,
          char *, m_toupper, (char * s),
          0, "toupper", "convert to uppercase")

DG_METHOD(M_TOLOWER, E_STRING, E_STRING,
          char *, m_tolower, (char * s),
          0, "tolower", "convert to lowercase")

DG_METHOD(M_FIT, E_STRING, E_STRING,
          char *, m_fit, (char * s, list p),
          0, "fit", "fit string into fixed width field")

/* Some methods intended to be used as filters... */
DG_METHOD(M_PAGE, E_STRING, E_STRING,
          char *, m_page, (char * s, list p),
          0, "page", "pagination filter")

DG_METHOD(M_TAB, E_STRING, E_STRING,
          char *, m_tab, (char * s, list p),
          0, "tab", "tabulation filter")


