
/*  A Bison parser, made from dgparse.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	INTEGER	257
#define	FLOATING	258
#define	STRING	259
#define	VAR	260
#define	IF	261
#define	ELSE	262
#define	ELSEIF	263
#define	ENDIF	264
#define	FOR	265
#define	FORALL	266
#define	NEXT	267
#define	KEEP	268
#define	IFNONE	269
#define	SORT	270
#define	SWITCH	271
#define	CASE	272
#define	ENDSWITCH	273
#define	METHOD	274
#define	RETURN	275
#define	THIS	276
#define	GLOBAL	277
#define	OUTFILE	278
#define	GE	279
#define	LE	280
#define	NE	281
#define	SHL	282
#define	SHR	283
#define	LOGAND	284
#define	LOGOR	285
#define	MATCHES	286
#define	STRICTMATCHES	287
#define	DBLSEMI	288
#define	REFERS	289
#define	EQ	290
#define	unary	291

#line 1 "dgparse.y"

/*****************************************************************************
*   $Id: dgparse.y,v 1.1.1.1 2000/06/22 15:39:03 tekno Exp $
*
*    Copyright (C) 2000, Stephen J. Hardy
*
*    techno@spirit.net.au
*    16 Powers Place, Latham, A.C.T. 2615, Australia
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
* $Log: dgparse.y,v $
* Revision 1.1.1.1  2000/06/22 15:39:03  tekno
* Opened source
*
*
*****************************************************************************/
#include "dglex.h"
#include <stdarg.h>
#include <stdlib.h>
#include <stdio.h>

#line 48 "dgparse.y"
typedef union
{
  int lex_int;       /* For INTEGER */
  char * lex_str;    /* STRING.
                        malloc()'d in lex */
  double lex_float;  /* For FLOATING */
  
  /* Now stuff for non-terminal nodes */
  tree   lex_tree;		/* Generic parse node */
  list   lex_list;		/* Generic list of nodes */
} YYSTYPE;
#line 124 "dgparse.y"


list tmpl_root;	/* Set to list of statements comprising entire template. */
int nest;	/* Statement nesting level */

#define MAX_NESTING 8	/* Levels we are interested in reporting */
static struct
{
  int lineno;
  char * filename;
  node_type nt;
} sstack[MAX_NESTING];

static void spush(node_type nt)
{
  /* Helps with error reporting.  Remembers file/line of start of compound
     statement which is being parsed.  If EOF encountered, then if any
     statement has not been terminated properly (e.g. forgetting an endif
     in an if statement), then we can indicate the line at which the
     statement started. */
  if (nest < MAX_NESTING)
  {
    /*fprintf(stderr, "pushd nest %d\n", nest);*/
    sstack[nest].lineno = lex_line;
    sstack[nest].filename = srcfilename;
    sstack[nest].nt = nt;
  }
}

static list start_list(tree t)
{
  list l;
  
  if (!t)  /* because called for immediate execution */
    return 0;
  l = (list)malloc(sizeof(*l));
  l->next = 0;
  l->val = t;
  if (!t)
    yyerror("start_list: null tree");
    
  return l;
}

static list add_tree(list l, tree t)
{
  /* Add t to end of list l. */
  list r;
  if (!l || !t)  /* because called for immediate execution */
    return l;
  for (r = l; r->next; r = r->next);
  r->next = start_list(t);
  return l;
}

static tree new_tree(node_type nt)
{
  /* We could be smarter about allocating the minimum size, but for
     now just allocate max size */
  tree t = (tree)calloc(sizeof(*t), 1);
  t->type = nt;
  t->lineno = lex_line;
  t->filename = srcfilename;
  return t;
}

static tree make_condition(int op, tree expr, list stmts)
{
  tree t = new_tree(T_COND);
  t->u.cn.oper = op;
  t->u.cn.cond = expr;
  t->u.cn.stmts = stmts;
  return t;
}

static tree make_exprnode(node_type nt, ...)
{
  tree t;	/* Return value */
  va_list ap;
  
  va_start(ap, nt);
  t = new_tree(nt);
  switch (nt)
  {
  case T_INT:
    t->u.intval = va_arg(ap, int);
    break;
  case T_FLOAT:
    /* Reserved for future use.  For now, floats are converted to int. */
    t->u.intval = (int)va_arg(ap, double);
    t->type = T_INT;
    break;
  case T_STRING:
    t->u.strval = va_arg(ap, char *);
    break;
  case T_VAR:
    t->u.var.varname = va_arg(ap, char *);
    t->u.var.global = va_arg(ap, int);
    break;
  case T_PARM:
    t->u.expr.left = make_exprnode(T_VAR, va_arg(ap, char *), 0);
    t->u.expr.right = va_arg(ap, tree);
    break;
  case T_REFERS:
    t->u.expr.left = make_exprnode(T_VAR, va_arg(ap, char *), 0);
    break;
  case T_METHOD:
    t->u.meth.obj = va_arg(ap, tree);  /* May be null for filter */
    t->u.meth.name = translate_methodname(t->u.meth.cust = va_arg(ap, char *));
    t->u.meth.parms = va_arg(ap, list);
    break;
  case T_UNARY:
    t->u.expr.oper = va_arg(ap, int);
    t->u.expr.right = va_arg(ap, tree);
    break;
  case T_BINARY:
    t->u.expr.left = va_arg(ap, tree);
    t->u.expr.oper = va_arg(ap, int);
    t->u.expr.right = va_arg(ap, tree);
    break;
  case T_INDEX:
    t->u.expr.left = va_arg(ap, tree);
    t->u.expr.right = va_arg(ap, tree);
    break;
  }
  va_end(ap);
  return t;
}

static tree make_statement(node_type nt, ...)
{
  tree t;	/* Return value */
  tree u, v, w;
  list l;
  va_list ap;
  int g;
  char * vn;
  
  va_start(ap, nt);
  t = new_tree(nt);
  switch (nt)
  {
  case T_SET:	/* Parms: varname, index, expression, global. */
    t->u.expr.oper = nt;
    vn = va_arg(ap, char *);
    u = va_arg(ap, tree);  /* Index expression */
    w = va_arg(ap, tree);  /* Value expr */
    g = va_arg(ap, int);   /* Global var */
    if (u)
      t->u.expr.left = make_exprnode(T_INDEX, make_exprnode(T_VAR, vn, g), u);
    else
      t->u.expr.left = make_exprnode(T_VAR, vn, g);
    t->u.expr.right = w;
    break;
  case T_IF:	/* Parms: expression, list of stmts for IF, list of cond nodes
  			for elseifs, single cond node for else. */
    /* Make cond for IF (cond) stmts part */
    v = va_arg(ap, tree);
    u = make_condition(0, v, va_arg(ap, list));
    t->u.cond.conds = start_list(u);
    l = va_arg(ap, list);
    while (l)
    {
      v = l->val; 
      add_tree(t->u.cond.conds, v);
      l = l->next;
    }
    v = va_arg(ap, tree);
    if (v)
      add_tree(t->u.cond.conds, v);
    break;
  case T_SWITCH:	/* Parms: expression, list of cond nodes for cases. */
    t->u.sw.expr = va_arg(ap, tree);
    t->u.sw.conds = va_arg(ap, list);
    break;
  case T_FOR:	/* Parms: list of init, test expr, list of assign, body list */
    t->u.loop.inits = va_arg(ap, list);
    t->u.loop.test = va_arg(ap, tree);
    t->u.loop.assigns = va_arg(ap, list);
    t->u.loop.stmts = va_arg(ap, list);
    break;
  case T_FORALL:	/* Parms: char * for datatype, 
                        char * for var,
                        keep expression or null (tree),
  			list of sort expressions,
  			list of ifnone statements,
  			list of statements */
    t->u.forall.datatype = va_arg(ap, tree);
    t->u.forall.var = make_exprnode(T_VAR, va_arg(ap, char *), 0);
    t->u.forall.keep = va_arg(ap, tree);
    t->u.forall.sort = va_arg(ap, list);
    t->u.forall.ifnone = va_arg(ap, list);
    t->u.forall.stmts = va_arg(ap, list);
    break;
  case T_FUNCTION:	/* Parms: tree thistype, char * for method name,
  			list of formal parms, list of statements,
  			return expression. */
    t->u.mdef.thistype = va_arg(ap, tree);
    t->u.mdef.name = va_arg(ap, char *);
    t->u.mdef.parms = va_arg(ap, list);
    t->u.mdef.stmts = va_arg(ap, list);
    t->u.mdef.ret = va_arg(ap, tree);
    break;
  case T_EXPR:	/* Parms: expression (tree), add CRLF (int) */
    t->u.expr.left = va_arg(ap, tree);
    t->u.expr.oper = va_arg(ap, int) ? T_CRLF : T_EXPR;
    break;
  case T_OUTFILE:  /* Parms: filter list */
    t->u.l = va_arg(ap, list);
    break;
  default:
    break;
  }
  va_end(ap);
  return t;
}

static tree imm_execute(tree t)
{
  /* Called at end of parsing outermost level statement when interpreting
     in immediate mode i.e. no -p (preparse) option.  Execute the statement
     then discard the tree of statements t to free resources.  Naturally,
     this mode of execution requires methods to be defined before they
     are invoked. */
  int rc;
  extern int exec_stmt(tree t);
  extern int recycle_stmt(tree t);
  
  if (!t)
    return 0;	/* This happens if syntax error */
  
  if (t->type == T_FUNCTION)
  {
    grok_mdef(t);
    return t;  /* Method defs must be retained */
  }
  rc = exec_stmt(t);
  recycle_stmt(t);
  if (rc)
    fprintf(stderr, "%s:%d: Error executing statement, rc=%d.\n", 
      t->filename, t->lineno, rc);
  return 0;
}
 
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		251
#define	YYFLAG		-32768
#define	YYNTBASE	57

#define YYTRANSLATE(x) ((unsigned)(x) <= 291 ? yytranslate[x] : 104)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    56,     2,     2,     2,    48,    40,     2,    51,
    52,    46,    44,    37,    45,    50,    47,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,    36,    42,
    53,    43,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    54,     2,    55,    39,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,    38,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    41,
    49
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,    13,    18,    24,    31,    39,    50,    52,    54,
    56,    58,    60,    63,    66,    69,    76,    80,    85,    90,
    94,    99,   108,   112,   117,   123,   134,   138,   145,   149,
   153,   155,   156,   158,   159,   162,   163,   167,   168,   172,
   176,   177,   179,   181,   185,   189,   196,   201,   209,   213,
   214,   216,   218,   221,   225,   226,   229,   230,   232,   234,
   237,   241,   246,   251,   252,   254,   256,   259,   262,   266,
   268,   271,   277,   279,   281,   286,   288,   292,   296,   300,
   304,   308,   312,   316,   320,   324,   328,   330,   333,   335,
   338,   339,   343,   345,   349,   350,   352,   354,   358,   361,
   364,   365,   368,   370,   372,   374,   376,   378,   380,   382,
   384,   386,   388,   390,   392,   394,   396,   398,   400,   402,
   404,   406,   410,   412,   414,   416,   418,   423,   424,   429,
   430
};

static const short yyrhs[] = {    65,
     0,    59,   101,    50,     6,    51,    90,    52,    65,    21,
    83,     0,    59,     1,    21,    83,     0,    59,   101,     1,
    21,    83,     0,    59,   101,    50,     1,    21,    83,     0,
    59,   101,    50,     6,     1,    21,    83,     0,    59,   101,
    50,     6,    51,    90,    52,     1,    21,    83,     0,    20,
     0,     7,     0,    17,     0,    11,     0,    12,     0,    85,
    36,     0,    85,    34,     0,    72,    36,     0,    60,    83,
    65,    73,    76,    10,     0,    60,     1,    10,     0,    60,
    83,     1,    10,     0,    61,    83,    77,    19,     0,    61,
     1,    19,     0,    61,    83,     1,    19,     0,    63,   100,
     6,   103,   102,    69,    65,    13,     0,    63,     1,    13,
     0,    63,   100,     1,    13,     0,    63,   100,     6,     1,
    13,     0,    62,    51,    70,    36,    85,    36,    70,    52,
    65,    13,     0,    62,     1,    13,     0,    62,    51,     1,
    52,    65,    13,     0,    24,    80,    36,     0,    24,     1,
    36,     0,    58,     0,     0,    66,     0,     0,    67,    64,
     0,     0,    66,    68,    64,     0,     0,    15,    66,    10,
     0,    15,     1,    10,     0,     0,    71,     0,    72,     0,
    71,    37,    72,     0,     6,    53,    85,     0,     6,    54,
    85,    55,    53,    85,     0,    23,     6,    53,    85,     0,
    23,     6,    54,    85,    55,    53,    85,     0,    22,    53,
    85,     0,     0,    74,     0,    75,     0,    74,    75,     0,
     9,    83,    65,     0,     0,     8,    65,     0,     0,    78,
     0,    79,     0,    78,    79,     0,    18,    83,    65,     0,
    18,    98,    83,    65,     0,    18,    99,    83,    65,     0,
     0,    81,     0,    82,     0,    81,    82,     0,     6,    88,
     0,    51,    85,    52,     0,   101,     0,    23,     6,     0,
    23,     6,    54,    85,    55,     0,    22,     0,    83,     0,
    84,    50,     6,    88,     0,    86,     0,    85,    95,    85,
     0,    85,    96,    85,     0,    85,    97,    85,     0,    85,
    98,    85,     0,    85,    99,    85,     0,    85,    40,    85,
     0,    85,    39,    85,     0,    85,    38,    85,     0,    85,
    30,    85,     0,    85,    31,    85,     0,    87,     0,    94,
    86,     0,    84,     0,    87,    84,     0,     0,    51,    89,
    52,     0,    85,     0,    89,    37,    85,     0,     0,    91,
     0,    92,     0,    91,    37,    92,     0,     6,    93,     0,
     6,    35,     0,     0,    53,    85,     0,    56,     0,    45,
     0,    32,     0,    46,     0,    47,     0,    48,     0,    44,
     0,    45,     0,    28,     0,    29,     0,    42,     0,    43,
     0,    25,     0,    26,     0,    41,     0,    27,     0,    32,
     0,    33,     0,     6,     0,     6,    50,     6,     0,     3,
     0,     4,     0,     5,     0,     6,     0,     6,    54,    85,
    55,     0,     0,    16,    51,    89,    52,     0,     0,    14,
    83,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   371,   383,   389,   393,   397,   401,   405,   412,   417,   422,
   427,   432,   437,   440,   443,   445,   452,   456,   460,   465,
   469,   473,   479,   483,   487,   491,   496,   500,   504,   507,
   511,   517,   520,   524,   526,   532,   534,   542,   545,   548,
   554,   557,   561,   564,   569,   572,   575,   578,   581,   586,
   589,   593,   596,   601,   606,   609,   614,   617,   621,   624,
   629,   632,   635,   640,   643,   647,   650,   655,   660,   665,
   667,   670,   674,   677,   679,   684,   686,   689,   692,   695,
   698,   701,   704,   707,   710,   713,   719,   721,   726,   728,
   733,   736,   741,   744,   749,   752,   756,   759,   764,   767,
   772,   775,   780,   782,   784,   789,   791,   793,   797,   799,
   803,   805,   809,   811,   813,   815,   819,   821,   823,   825,
   830,   833,   840,   843,   846,   849,   852,   858,   861,   866,
   869
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","INTEGER",
"FLOATING","STRING","VAR","IF","ELSE","ELSEIF","ENDIF","FOR","FORALL","NEXT",
"KEEP","IFNONE","SORT","SWITCH","CASE","ENDSWITCH","METHOD","RETURN","THIS",
"GLOBAL","OUTFILE","GE","LE","NE","SHL","SHR","LOGAND","LOGOR","MATCHES","STRICTMATCHES",
"DBLSEMI","REFERS","';'","','","'|'","'^'","'&'","EQ","'<'","'>'","'+'","'-'",
"'*'","'/'","'%'","unary","'.'","'('","')'","'='","'['","']'","'!'","tmpl","method_def",
"method_head","if_head","switch_head","for_head","forall_head","tmpl_statement",
"opt_statements","statements","@1","@2","opt_ifnone","opt_assignments","assignments",
"assignment","opt_elseifs","elseifs","elseif","opt_else","opt_cases","cases",
"case","opt_filters","filters","filter","brkt_expr","primary","expression","unary_expr",
"primarycat","opt_parms","parms","opt_formal_parms","formal_parms","formal_parm",
"opt_parm_init","unary_op","multiplicative_op","additive_op","shift_op","comparison_op",
"equality_op","datatype","thistype","opt_sort","opt_subset", NULL
};
#endif

static const short yyr1[] = {     0,
    57,    58,    58,    58,    58,    58,    58,    59,    60,    61,
    62,    63,    64,    64,    64,    64,    64,    64,    64,    64,
    64,    64,    64,    64,    64,    64,    64,    64,    64,    64,
    64,    65,    65,    67,    66,    68,    66,    69,    69,    69,
    70,    70,    71,    71,    72,    72,    72,    72,    72,    73,
    73,    74,    74,    75,    76,    76,    77,    77,    78,    78,
    79,    79,    79,    80,    80,    81,    81,    82,    83,    84,
    84,    84,    84,    84,    84,    85,    85,    85,    85,    85,
    85,    85,    85,    85,    85,    85,    86,    86,    87,    87,
    88,    88,    89,    89,    90,    90,    91,    91,    92,    92,
    93,    93,    94,    94,    94,    95,    95,    95,    96,    96,
    97,    97,    98,    98,    98,    98,    99,    99,    99,    99,
   100,   100,   101,   101,   101,   101,   101,   102,   102,   103,
   103
};

static const short yyr2[] = {     0,
     1,    10,     4,     5,     6,     7,    10,     1,     1,     1,
     1,     1,     2,     2,     2,     6,     3,     4,     4,     3,
     4,     8,     3,     4,     5,    10,     3,     6,     3,     3,
     1,     0,     1,     0,     2,     0,     3,     0,     3,     3,
     0,     1,     1,     3,     3,     6,     4,     7,     3,     0,
     1,     1,     2,     3,     0,     2,     0,     1,     1,     2,
     3,     4,     4,     0,     1,     1,     2,     2,     3,     1,
     2,     5,     1,     1,     4,     1,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     1,     2,     1,     2,
     0,     3,     1,     3,     0,     1,     1,     3,     2,     2,
     0,     2,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     3,     1,     1,     1,     1,     4,     0,     4,     0,
     2
};

static const short yydefact[] = {    34,
     1,    36,     0,     0,   123,   124,   125,   126,     9,    11,
    12,    10,     8,    73,     0,     0,   105,   104,     0,   103,
    31,     0,     0,     0,     0,     0,    35,     0,    74,    89,
     0,    76,    87,     0,    70,    37,     0,     0,     0,    71,
     0,    91,     0,    65,    66,   126,    73,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   121,     0,
    15,     0,   115,   116,   118,   111,   112,     0,     0,   119,
   120,    14,    13,     0,     0,     0,   117,   113,   114,   109,
   110,   106,   107,   108,     0,     0,     0,     0,     0,    90,
    88,    45,     0,    49,     0,     0,    30,     0,    68,    29,
    67,     0,    71,    69,     0,     0,     0,    17,     0,    50,
    20,     0,     0,     0,    58,    59,    27,     0,     0,     0,
     0,     0,    42,    43,    23,     0,     0,     0,    91,    85,
    86,    84,    83,    82,    77,    78,    79,    80,    81,   127,
    47,     0,    93,     0,     0,     0,     3,     0,     0,     0,
    18,     0,    55,    51,    52,    21,    34,     0,     0,    19,
    60,    34,     0,     0,     0,     0,   122,    24,     0,     0,
   128,    75,     0,    72,     0,    92,   127,     0,     4,     0,
     0,    95,    34,    34,     0,    53,    61,    34,    34,     0,
     0,     0,     0,    44,    25,   131,     0,    38,    46,     0,
    94,    72,     5,     0,   101,     0,    96,    97,    54,    56,
    16,    62,    63,    28,     0,     0,    41,     0,     0,    34,
    48,     6,   100,     0,    99,     0,     0,     0,     0,     0,
     0,    36,     0,   102,     0,     0,    98,    34,   129,    40,
    39,    22,     0,     0,     0,     7,     2,    26,     0,     0,
     0
};

static const short yydefgoto[] = {   249,
    21,    22,    23,    24,    25,    26,    27,     1,     2,     3,
     4,   220,   122,   123,    28,   153,   154,   155,   185,   114,
   115,   116,    43,    44,    45,    29,    30,    31,    32,    33,
    99,   144,   206,   207,   208,   225,    34,    85,    86,    87,
    88,    89,    60,    35,   198,   171
};

static const short yypact[] = {    44,
-32768,   326,   301,   301,-32768,-32768,-32768,    42,-32768,-32768,
-32768,-32768,-32768,   -46,     8,    33,-32768,-32768,     6,-32768,
-32768,   161,     4,     5,     7,    40,-32768,    11,-32768,   -10,
   547,-32768,    27,     6,-32768,-32768,     6,     6,     6,    54,
    29,    26,    43,    69,-32768,    32,-32768,    94,   519,    77,
    14,   116,   241,   109,    24,   121,    91,   129,   101,    87,
-32768,   138,-32768,-32768,-32768,-32768,-32768,     6,     6,-32768,
-32768,-32768,-32768,     6,     6,     6,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,     6,     6,     6,     6,     6,   -10,
-32768,   595,   333,   595,     6,     6,-32768,     6,-32768,-32768,
-32768,     6,    99,-32768,   104,   135,    88,-32768,   142,   150,
-32768,   149,    -6,   151,   143,-32768,-32768,   119,    63,   -46,
   168,   140,   141,-32768,-32768,   178,   173,   211,    26,   643,
   619,   667,   691,   715,-32768,   -30,   160,   144,   154,   157,
   595,   364,   595,    15,   395,     6,-32768,   104,   172,    12,
-32768,   104,   186,   150,-32768,-32768,   105,   104,   104,-32768,
-32768,   182,     6,    92,     6,    62,-32768,-32768,   198,   104,
   197,-32768,     6,   166,     6,-32768,-32768,   426,-32768,   104,
   208,   224,   131,   222,   226,-32768,-32768,   105,   105,   225,
   457,     6,   571,-32768,-32768,-32768,   188,   239,   595,     6,
   595,-32768,-32768,   104,    13,   185,   203,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,   157,   488,    62,     6,   271,   182,
   595,-32768,-32768,     6,-32768,    98,   224,   166,   189,    39,
   245,   247,   246,   595,   248,   249,-32768,   182,-32768,-32768,
-32768,-32768,   104,   104,   253,-32768,-32768,-32768,   260,   268,
-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   267,   -51,    60,-32768,
-32768,-32768,    64,-32768,   -54,-32768,-32768,   126,-32768,-32768,
-32768,   169,-32768,-32768,   243,   -23,   252,   -15,   255,-32768,
   167,    72,-32768,-32768,    71,-32768,-32768,-32768,-32768,-32768,
   187,   196,-32768,   277,-32768,-32768
};


#define	YYLAST		763


static const short yytable[] = {    53,
    55,   110,   124,    49,    52,    54,    39,    56,     5,     6,
     7,    46,   181,    40,   106,    82,    83,    84,    63,    64,
    65,    92,    93,    94,   112,    70,    71,    47,    48,     5,
     6,     7,    46,    41,    77,    78,    79,    17,    42,    62,
    58,   113,   -57,   -32,    19,    59,    61,   223,    47,    48,
    18,   175,   130,   131,    19,    19,    19,    57,   132,   133,
   134,    20,   182,   107,    97,   224,   176,   119,   -64,   135,
   136,   137,   138,   139,    42,   175,    98,    19,   100,   141,
   142,   147,   143,   120,   121,   102,   145,   127,   149,   157,
   239,   118,   128,   150,    37,    38,   119,   105,   235,   103,
   -34,   -34,   -34,   -34,   -34,   187,    95,    96,   -34,   -34,
   190,   194,   120,   121,   -34,    37,   163,   -34,   -32,   -34,
   -34,   -34,   -32,   -32,   179,   108,   -41,   111,   183,   -34,
   178,   209,   210,   117,   188,   189,   212,   213,   -32,   -32,
   -32,   125,   -34,   129,    95,   192,   196,   191,   -34,   193,
   126,   151,   146,   -34,    19,   148,   203,   199,   152,   201,
   113,    50,   124,     5,     6,     7,    46,   156,   233,   160,
   162,    66,    67,   164,   236,   165,   216,   166,    63,    64,
   222,    66,    67,   167,   221,   168,   245,    80,    81,    82,
    83,    84,   180,   184,   -32,    78,    79,    80,    81,    82,
    83,    84,   143,    80,    81,    82,    83,    84,   234,   173,
   195,   169,   197,  -130,  -130,  -130,  -130,  -130,   200,   246,
   247,  -130,  -130,  -130,   170,  -130,  -130,  -130,   204,   205,
  -130,   -32,  -130,  -130,  -130,   211,   226,   214,   218,   227,
   238,   109,  -130,   -34,   -34,   -34,   -34,   -34,   -32,   -32,
   -32,   -34,   -34,   219,   240,  -130,   241,   -34,   242,   250,
   -34,  -130,   -34,   -34,   -34,   248,  -130,   251,   243,   244,
    36,   231,   -34,   -34,   -34,   -34,   -34,   -34,   232,   186,
   229,   -34,   -34,   161,    90,   -34,   101,   -34,    91,   230,
   -34,   -34,   -34,   -34,   -34,   172,   -34,   237,    51,   158,
     0,     0,   -34,     5,     6,     7,     8,     9,   159,     0,
     0,    10,    11,     0,     0,   -34,     0,    12,     0,     0,
    13,   -34,    14,    15,    16,   -33,   -34,     0,     0,     0,
     0,     0,    17,   -33,   -33,   -33,     0,     0,   -33,     0,
     0,     0,     0,   -33,   -33,    18,   -33,     0,     0,     0,
     0,    19,     0,     0,     0,     0,    20,    63,    64,    65,
    66,    67,    68,    69,    70,    71,     0,     0,     0,     0,
    74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
    84,     0,     0,     0,     0,     0,     0,   140,    63,    64,
    65,    66,    67,    68,    69,    70,    71,     0,     0,     0,
     0,    74,    75,    76,    77,    78,    79,    80,    81,    82,
    83,    84,     0,     0,     0,     0,     0,     0,   174,    63,
    64,    65,    66,    67,    68,    69,    70,    71,     0,     0,
     0,     0,    74,    75,    76,    77,    78,    79,    80,    81,
    82,    83,    84,     0,     0,     0,     0,     0,     0,   177,
    63,    64,    65,    66,    67,    68,    69,    70,    71,     0,
     0,     0,     0,    74,    75,    76,    77,    78,    79,    80,
    81,    82,    83,    84,     0,     0,     0,     0,     0,     0,
   202,    63,    64,    65,    66,    67,    68,    69,    70,    71,
     0,     0,     0,     0,    74,    75,    76,    77,    78,    79,
    80,    81,    82,    83,    84,     0,     0,     0,     0,     0,
     0,   215,    63,    64,    65,    66,    67,    68,    69,    70,
    71,     0,     0,     0,     0,    74,    75,    76,    77,    78,
    79,    80,    81,    82,    83,    84,     0,     0,     0,     0,
     0,     0,   228,    63,    64,    65,    66,    67,    68,    69,
    70,    71,     0,     0,     0,     0,    74,    75,    76,    77,
    78,    79,    80,    81,    82,    83,    84,     0,     0,     0,
   104,    63,    64,    65,    66,    67,    68,    69,    70,    71,
    72,     0,    73,     0,    74,    75,    76,    77,    78,    79,
    80,    81,    82,    83,    84,    63,    64,    65,    66,    67,
    68,    69,    70,    71,     0,     0,   217,     0,    74,    75,
    76,    77,    78,    79,    80,    81,    82,    83,    84,    63,
    64,    65,    66,    67,    68,    69,    70,    71,     0,     0,
     0,     0,    74,    75,    76,    77,    78,    79,    80,    81,
    82,    83,    84,    63,    64,    65,    66,    67,    68,     0,
    70,    71,     0,     0,     0,     0,    74,    75,    76,    77,
    78,    79,    80,    81,    82,    83,    84,    63,    64,    65,
    66,    67,     0,     0,    70,    71,     0,     0,     0,     0,
    74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
    84,    63,    64,    65,    66,    67,     0,     0,    70,    71,
     0,     0,     0,     0,     0,    75,    76,    77,    78,    79,
    80,    81,    82,    83,    84,    63,    64,    65,    66,    67,
     0,     0,    70,    71,     0,     0,     0,     0,     0,     0,
    76,    77,    78,    79,    80,    81,    82,    83,    84,    63,
    64,    65,    66,    67,     0,     0,    70,    71,     0,     0,
     0,     0,     0,     0,     0,    77,    78,    79,    80,    81,
    82,    83,    84
};

static const short yycheck[] = {    23,
    24,    53,    57,    19,     1,     1,    53,     1,     3,     4,
     5,     6,     1,     6,     1,    46,    47,    48,    25,    26,
    27,    37,    38,    39,     1,    32,    33,    22,    23,     3,
     4,     5,     6,     1,    41,    42,    43,    32,     6,    50,
     1,    18,    19,     0,    51,     6,    36,    35,    22,    23,
    45,    37,    68,    69,    51,    51,    51,    51,    74,    75,
    76,    56,    51,    50,    36,    53,    52,     6,    36,    85,
    86,    87,    88,    89,     6,    37,    51,    51,    36,    95,
    96,   105,    98,    22,    23,    54,   102,     1,     1,   113,
    52,     1,     6,     6,    53,    54,     6,    21,     1,     6,
     3,     4,     5,     6,     7,   157,    53,    54,    11,    12,
   162,   166,    22,    23,    17,    53,    54,    20,    21,    22,
    23,    24,    18,    19,   148,    10,    36,    19,   152,    32,
   146,   183,   184,    13,   158,   159,   188,   189,     8,     9,
    10,    13,    45,     6,    53,    54,   170,   163,    51,   165,
    50,    10,    54,    56,    51,    21,   180,   173,     9,   175,
    18,     1,   217,     3,     4,     5,     6,    19,   220,    19,
    52,    28,    29,     6,   226,    36,   192,    37,    25,    26,
   204,    28,    29,     6,   200,    13,   238,    44,    45,    46,
    47,    48,    21,     8,    13,    42,    43,    44,    45,    46,
    47,    48,   218,    44,    45,    46,    47,    48,   224,    53,
    13,     1,    16,     3,     4,     5,     6,     7,    53,   243,
   244,    11,    12,    13,    14,    15,    16,    17,    21,     6,
    20,    10,    22,    23,    24,    10,    52,    13,    51,    37,
    52,     1,    32,     3,     4,     5,     6,     7,     8,     9,
    10,    11,    12,    15,    10,    45,    10,    17,    13,     0,
    20,    51,    22,    23,    24,    13,    56,     0,    21,    21,
     4,     1,    32,     3,     4,     5,     6,     7,   219,   154,
   217,    11,    12,   115,    33,    45,    44,    17,    34,   218,
    20,    51,    22,    23,    24,   129,    56,   227,    22,   113,
    -1,    -1,    32,     3,     4,     5,     6,     7,   113,    -1,
    -1,    11,    12,    -1,    -1,    45,    -1,    17,    -1,    -1,
    20,    51,    22,    23,    24,     0,    56,    -1,    -1,    -1,
    -1,    -1,    32,     8,     9,    10,    -1,    -1,    13,    -1,
    -1,    -1,    -1,    18,    19,    45,    21,    -1,    -1,    -1,
    -1,    51,    -1,    -1,    -1,    -1,    56,    25,    26,    27,
    28,    29,    30,    31,    32,    33,    -1,    -1,    -1,    -1,
    38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
    48,    -1,    -1,    -1,    -1,    -1,    -1,    55,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    -1,    -1,    -1,
    -1,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    -1,    -1,    -1,    -1,    -1,    -1,    55,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    -1,    -1,
    -1,    -1,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    -1,    -1,    -1,    -1,    -1,    -1,    55,
    25,    26,    27,    28,    29,    30,    31,    32,    33,    -1,
    -1,    -1,    -1,    38,    39,    40,    41,    42,    43,    44,
    45,    46,    47,    48,    -1,    -1,    -1,    -1,    -1,    -1,
    55,    25,    26,    27,    28,    29,    30,    31,    32,    33,
    -1,    -1,    -1,    -1,    38,    39,    40,    41,    42,    43,
    44,    45,    46,    47,    48,    -1,    -1,    -1,    -1,    -1,
    -1,    55,    25,    26,    27,    28,    29,    30,    31,    32,
    33,    -1,    -1,    -1,    -1,    38,    39,    40,    41,    42,
    43,    44,    45,    46,    47,    48,    -1,    -1,    -1,    -1,
    -1,    -1,    55,    25,    26,    27,    28,    29,    30,    31,
    32,    33,    -1,    -1,    -1,    -1,    38,    39,    40,    41,
    42,    43,    44,    45,    46,    47,    48,    -1,    -1,    -1,
    52,    25,    26,    27,    28,    29,    30,    31,    32,    33,
    34,    -1,    36,    -1,    38,    39,    40,    41,    42,    43,
    44,    45,    46,    47,    48,    25,    26,    27,    28,    29,
    30,    31,    32,    33,    -1,    -1,    36,    -1,    38,    39,
    40,    41,    42,    43,    44,    45,    46,    47,    48,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    -1,    -1,
    -1,    -1,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    25,    26,    27,    28,    29,    30,    -1,
    32,    33,    -1,    -1,    -1,    -1,    38,    39,    40,    41,
    42,    43,    44,    45,    46,    47,    48,    25,    26,    27,
    28,    29,    -1,    -1,    32,    33,    -1,    -1,    -1,    -1,
    38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
    48,    25,    26,    27,    28,    29,    -1,    -1,    32,    33,
    -1,    -1,    -1,    -1,    -1,    39,    40,    41,    42,    43,
    44,    45,    46,    47,    48,    25,    26,    27,    28,    29,
    -1,    -1,    32,    33,    -1,    -1,    -1,    -1,    -1,    -1,
    40,    41,    42,    43,    44,    45,    46,    47,    48,    25,
    26,    27,    28,    29,    -1,    -1,    32,    33,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    41,    42,    43,    44,    45,
    46,    47,    48
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 373 "dgparse.y"
{ 
		  tmpl_root = yyvsp[0].lex_list;
		  if (!preparse)
		  {
		    extern void flush_filters(void);
		    flush_filters();
		  }
		;
    break;}
case 2:
#line 387 "dgparse.y"
{ yyval.lex_tree = make_statement(T_FUNCTION, yyvsp[-8].lex_tree, yyvsp[-6].lex_str, yyvsp[-4].lex_list, yyvsp[-2].lex_list, yyvsp[0].lex_tree); 
		;
    break;}
case 3:
#line 391 "dgparse.y"
{ yyval.lex_tree = 0;
		  yyerror("method definition error: expecting subject type"); ;
    break;}
case 4:
#line 395 "dgparse.y"
{ yyval.lex_tree = 0;
		  yyerror("method definition error: expecting '.'"); ;
    break;}
case 5:
#line 399 "dgparse.y"
{ yyval.lex_tree = 0; 
		  yyerror("method definition error: expecting method name"); ;
    break;}
case 6:
#line 403 "dgparse.y"
{ yyval.lex_tree = 0; 
		  yyerror("method definition error: expecting formal parms"); ;
    break;}
case 7:
#line 408 "dgparse.y"
{ yyval.lex_tree = 0; 
		  yyerror("method definition error: error in body"); ;
    break;}
case 8:
#line 414 "dgparse.y"
{ spush(T_FUNCTION); ;
    break;}
case 10:
#line 424 "dgparse.y"
{ spush(T_SWITCH); ;
    break;}
case 11:
#line 429 "dgparse.y"
{ spush(T_FOR); ;
    break;}
case 12:
#line 434 "dgparse.y"
{ spush(T_FORALL); ;
    break;}
case 13:
#line 439 "dgparse.y"
{ yyval.lex_tree = make_statement(T_EXPR, yyvsp[-1].lex_tree, 1); ;
    break;}
case 14:
#line 442 "dgparse.y"
{ yyval.lex_tree = make_statement(T_EXPR, yyvsp[-1].lex_tree, 0); ;
    break;}
case 16:
#line 451 "dgparse.y"
{ yyval.lex_tree = make_statement(T_IF, yyvsp[-4].lex_tree, yyvsp[-3].lex_list, yyvsp[-2].lex_list, yyvsp[-1].lex_tree); ;
    break;}
case 17:
#line 454 "dgparse.y"
{ yyval.lex_tree = 0;
		  yyerror("if statement error: expecting control expression"); ;
    break;}
case 18:
#line 458 "dgparse.y"
{ yyval.lex_tree = 0;
		  yyerror("if statement: error in body"); ;
    break;}
case 19:
#line 464 "dgparse.y"
{ yyval.lex_tree = make_statement(T_SWITCH, yyvsp[-2].lex_tree, yyvsp[-1].lex_list); ;
    break;}
case 20:
#line 467 "dgparse.y"
{ yyval.lex_tree = 0;
		  yyerror("switch statement: expecting control expression"); ;
    break;}
case 21:
#line 471 "dgparse.y"
{ yyval.lex_tree = 0;
		  yyerror("switch statement: error in body"); ;
    break;}
case 22:
#line 478 "dgparse.y"
{ yyval.lex_tree = make_statement(T_FORALL, yyvsp[-6].lex_tree, yyvsp[-5].lex_str, yyvsp[-4].lex_tree, yyvsp[-3].lex_list, yyvsp[-2].lex_list, yyvsp[-1].lex_list); ;
    break;}
case 23:
#line 481 "dgparse.y"
{ yyval.lex_tree = 0;
		  yyerror("forall statement: expecting datatype"); ;
    break;}
case 24:
#line 485 "dgparse.y"
{ yyval.lex_tree = 0;
		  yyerror("forall statement: expecting control variable"); ;
    break;}
case 25:
#line 489 "dgparse.y"
{ yyval.lex_tree = 0;
		  yyerror("forall statement: expecting options/statements"); ;
    break;}
case 26:
#line 495 "dgparse.y"
{ yyval.lex_tree = make_statement(T_FOR, yyvsp[-7].lex_list, yyvsp[-5].lex_tree, yyvsp[-3].lex_list, yyvsp[-1].lex_list); ;
    break;}
case 27:
#line 498 "dgparse.y"
{ yyval.lex_tree = 0;
		  yyerror("for statement: expecting '('"); ;
    break;}
case 28:
#line 502 "dgparse.y"
{ yyval.lex_tree = 0;
		  yyerror("for statement: error in loop control"); ;
    break;}
case 29:
#line 506 "dgparse.y"
{ yyval.lex_tree = make_statement(T_OUTFILE, yyvsp[-1].lex_list); ;
    break;}
case 30:
#line 509 "dgparse.y"
{ yyval.lex_tree = 0;
		  yyerror("outfile statement error"); ;
    break;}
case 32:
#line 519 "dgparse.y"
{ yyval.lex_list = 0; ;
    break;}
case 34:
#line 525 "dgparse.y"
{ nest++; spush(T_EXPR); ;
    break;}
case 35:
#line 526 "dgparse.y"
{ nest--; 
		  if (!preparse && !nest)
		    yyval.lex_list = start_list(imm_execute(yyvsp[0].lex_tree));
		  else
		    yyval.lex_list = start_list(yyvsp[0].lex_tree);
		;
    break;}
case 36:
#line 533 "dgparse.y"
{nest++; spush(T_EXPR); ;
    break;}
case 37:
#line 534 "dgparse.y"
{ nest--; 
		  if (!preparse && !nest)
		    yyval.lex_list = add_tree(yyvsp[-2].lex_list, imm_execute(yyvsp[0].lex_tree));
		  else
		    yyval.lex_list = add_tree(yyvsp[-2].lex_list, yyvsp[0].lex_tree); 
		;
    break;}
case 38:
#line 544 "dgparse.y"
{ yyval.lex_list = 0; ;
    break;}
case 39:
#line 547 "dgparse.y"
{ yyval.lex_list = yyvsp[-1].lex_list; ;
    break;}
case 40:
#line 550 "dgparse.y"
{ yyval.lex_list = 0;
		  yyerror("ifnone clause error"); ;
    break;}
case 41:
#line 556 "dgparse.y"
{ yyval.lex_list = 0; ;
    break;}
case 43:
#line 563 "dgparse.y"
{ yyval.lex_list = start_list(yyvsp[0].lex_tree); ;
    break;}
case 44:
#line 566 "dgparse.y"
{ yyval.lex_list = add_tree(yyvsp[-2].lex_list, yyvsp[0].lex_tree); ;
    break;}
case 45:
#line 571 "dgparse.y"
{ yyval.lex_tree = make_statement(T_SET, yyvsp[-2].lex_str, 0, yyvsp[0].lex_tree, 0); ;
    break;}
case 46:
#line 574 "dgparse.y"
{ yyval.lex_tree = make_statement(T_SET, yyvsp[-5].lex_str, yyvsp[-3].lex_tree, yyvsp[0].lex_tree, 0); ;
    break;}
case 47:
#line 577 "dgparse.y"
{ yyval.lex_tree = make_statement(T_SET, yyvsp[-2].lex_str, 0, yyvsp[0].lex_tree, 1); ;
    break;}
case 48:
#line 580 "dgparse.y"
{ yyval.lex_tree = make_statement(T_SET, yyvsp[-5].lex_str, yyvsp[-3].lex_tree, yyvsp[0].lex_tree, 1); ;
    break;}
case 49:
#line 583 "dgparse.y"
{ yyval.lex_tree = make_statement(T_SET, 0, 0, yyvsp[0].lex_tree, 0); ;
    break;}
case 50:
#line 588 "dgparse.y"
{ yyval.lex_list = 0; ;
    break;}
case 52:
#line 595 "dgparse.y"
{ yyval.lex_list = start_list(yyvsp[0].lex_tree); ;
    break;}
case 53:
#line 598 "dgparse.y"
{ yyval.lex_list = add_tree(yyvsp[-1].lex_list, yyvsp[0].lex_tree); ;
    break;}
case 54:
#line 603 "dgparse.y"
{ yyval.lex_tree = make_condition(0, yyvsp[-1].lex_tree, yyvsp[0].lex_list); ;
    break;}
case 55:
#line 608 "dgparse.y"
{ yyval.lex_tree = 0; ;
    break;}
case 56:
#line 611 "dgparse.y"
{ yyval.lex_tree = make_condition(0, 0, yyvsp[0].lex_list); ;
    break;}
case 57:
#line 616 "dgparse.y"
{ yyval.lex_list = 0; ;
    break;}
case 59:
#line 623 "dgparse.y"
{ yyval.lex_list = start_list(yyvsp[0].lex_tree); ;
    break;}
case 60:
#line 626 "dgparse.y"
{ yyval.lex_list = add_tree(yyvsp[-1].lex_list, yyvsp[0].lex_tree); ;
    break;}
case 61:
#line 631 "dgparse.y"
{ yyval.lex_tree = make_condition(EQ, yyvsp[-1].lex_tree, yyvsp[0].lex_list); ;
    break;}
case 62:
#line 634 "dgparse.y"
{ yyval.lex_tree = make_condition(yyvsp[-2].lex_int, yyvsp[-1].lex_tree, yyvsp[0].lex_list); ;
    break;}
case 63:
#line 637 "dgparse.y"
{ yyval.lex_tree = make_condition(yyvsp[-2].lex_int, yyvsp[-1].lex_tree, yyvsp[0].lex_list); ;
    break;}
case 64:
#line 642 "dgparse.y"
{ yyval.lex_list = 0; ;
    break;}
case 66:
#line 649 "dgparse.y"
{ yyval.lex_list = start_list(yyvsp[0].lex_tree); ;
    break;}
case 67:
#line 652 "dgparse.y"
{ yyval.lex_list = add_tree(yyvsp[-1].lex_list, yyvsp[0].lex_tree); ;
    break;}
case 68:
#line 657 "dgparse.y"
{ yyval.lex_tree = make_exprnode(T_METHOD, 0, yyvsp[-1].lex_str, yyvsp[0].lex_list); ;
    break;}
case 69:
#line 662 "dgparse.y"
{ yyval.lex_tree = yyvsp[-1].lex_tree; ;
    break;}
case 71:
#line 669 "dgparse.y"
{ yyval.lex_tree = make_exprnode(T_VAR, yyvsp[0].lex_str, 1); ;
    break;}
case 72:
#line 672 "dgparse.y"
{ yyval.lex_tree = make_exprnode(T_INDEX, 
		                     make_exprnode(T_VAR, yyvsp[-3].lex_str, 1), yyvsp[-1].lex_tree); ;
    break;}
case 73:
#line 676 "dgparse.y"
{ yyval.lex_tree = make_exprnode(T_VAR, 0, 0); ;
    break;}
case 75:
#line 681 "dgparse.y"
{ yyval.lex_tree = make_exprnode(T_METHOD, yyvsp[-3].lex_tree, yyvsp[-1].lex_str, yyvsp[0].lex_list); ;
    break;}
case 77:
#line 688 "dgparse.y"
{ yyval.lex_tree = make_exprnode(T_BINARY, yyvsp[-2].lex_tree, yyvsp[-1].lex_int, yyvsp[0].lex_tree); ;
    break;}
case 78:
#line 691 "dgparse.y"
{ yyval.lex_tree = make_exprnode(T_BINARY, yyvsp[-2].lex_tree, yyvsp[-1].lex_int, yyvsp[0].lex_tree); ;
    break;}
case 79:
#line 694 "dgparse.y"
{ yyval.lex_tree = make_exprnode(T_BINARY, yyvsp[-2].lex_tree, yyvsp[-1].lex_int, yyvsp[0].lex_tree); ;
    break;}
case 80:
#line 697 "dgparse.y"
{ yyval.lex_tree = make_exprnode(T_BINARY, yyvsp[-2].lex_tree, yyvsp[-1].lex_int, yyvsp[0].lex_tree); ;
    break;}
case 81:
#line 700 "dgparse.y"
{ yyval.lex_tree = make_exprnode(T_BINARY, yyvsp[-2].lex_tree, yyvsp[-1].lex_int, yyvsp[0].lex_tree); ;
    break;}
case 82:
#line 703 "dgparse.y"
{ yyval.lex_tree = make_exprnode(T_BINARY, yyvsp[-2].lex_tree, '&', yyvsp[0].lex_tree); ;
    break;}
case 83:
#line 706 "dgparse.y"
{ yyval.lex_tree = make_exprnode(T_BINARY, yyvsp[-2].lex_tree, '^', yyvsp[0].lex_tree); ;
    break;}
case 84:
#line 709 "dgparse.y"
{ yyval.lex_tree = make_exprnode(T_BINARY, yyvsp[-2].lex_tree, '|', yyvsp[0].lex_tree); ;
    break;}
case 85:
#line 712 "dgparse.y"
{ yyval.lex_tree = make_exprnode(T_BINARY, yyvsp[-2].lex_tree, LOGAND, yyvsp[0].lex_tree); ;
    break;}
case 86:
#line 715 "dgparse.y"
{ yyval.lex_tree = make_exprnode(T_BINARY, yyvsp[-2].lex_tree, LOGOR, yyvsp[0].lex_tree); ;
    break;}
case 88:
#line 723 "dgparse.y"
{ yyval.lex_tree = make_exprnode(T_UNARY, yyvsp[-1].lex_int, yyvsp[0].lex_tree); ;
    break;}
case 90:
#line 730 "dgparse.y"
{ yyval.lex_tree = make_exprnode(T_BINARY, yyvsp[-1].lex_tree, '#', yyvsp[0].lex_tree); ;
    break;}
case 91:
#line 735 "dgparse.y"
{ yyval.lex_list = 0; ;
    break;}
case 92:
#line 738 "dgparse.y"
{ yyval.lex_list = yyvsp[-1].lex_list; ;
    break;}
case 93:
#line 743 "dgparse.y"
{ yyval.lex_list = start_list(yyvsp[0].lex_tree); ;
    break;}
case 94:
#line 746 "dgparse.y"
{ yyval.lex_list = add_tree(yyvsp[-2].lex_list, yyvsp[0].lex_tree); ;
    break;}
case 95:
#line 751 "dgparse.y"
{ yyval.lex_list = 0; ;
    break;}
case 97:
#line 758 "dgparse.y"
{ yyval.lex_list = start_list(yyvsp[0].lex_tree); ;
    break;}
case 98:
#line 761 "dgparse.y"
{ yyval.lex_list = add_tree(yyvsp[-2].lex_list, yyvsp[0].lex_tree); ;
    break;}
case 99:
#line 766 "dgparse.y"
{ yyval.lex_tree = make_exprnode(T_PARM, yyvsp[-1].lex_str, yyvsp[0].lex_tree); ;
    break;}
case 100:
#line 769 "dgparse.y"
{ yyval.lex_tree = make_exprnode(T_REFERS, yyvsp[-1].lex_str); ;
    break;}
case 101:
#line 774 "dgparse.y"
{ yyval.lex_tree = 0; ;
    break;}
case 102:
#line 777 "dgparse.y"
{ yyval.lex_tree = yyvsp[0].lex_tree; ;
    break;}
case 103:
#line 781 "dgparse.y"
{ yyval.lex_int = '!'; ;
    break;}
case 104:
#line 783 "dgparse.y"
{ yyval.lex_int = '-'; ;
    break;}
case 105:
#line 785 "dgparse.y"
{ yyval.lex_int = '~'; ;
    break;}
case 106:
#line 790 "dgparse.y"
{ yyval.lex_int = '*'; ;
    break;}
case 107:
#line 792 "dgparse.y"
{ yyval.lex_int = '/'; ;
    break;}
case 108:
#line 794 "dgparse.y"
{ yyval.lex_int = '%'; ;
    break;}
case 109:
#line 798 "dgparse.y"
{ yyval.lex_int = '+'; ;
    break;}
case 110:
#line 800 "dgparse.y"
{ yyval.lex_int = '-'; ;
    break;}
case 111:
#line 804 "dgparse.y"
{ yyval.lex_int = SHL; ;
    break;}
case 112:
#line 806 "dgparse.y"
{ yyval.lex_int = SHR; ;
    break;}
case 113:
#line 810 "dgparse.y"
{ yyval.lex_int = '<'; ;
    break;}
case 114:
#line 812 "dgparse.y"
{ yyval.lex_int = '>'; ;
    break;}
case 115:
#line 814 "dgparse.y"
{ yyval.lex_int = GE; ;
    break;}
case 116:
#line 816 "dgparse.y"
{ yyval.lex_int = LE; ;
    break;}
case 117:
#line 820 "dgparse.y"
{ yyval.lex_int = EQ; ;
    break;}
case 118:
#line 822 "dgparse.y"
{ yyval.lex_int = NE; ;
    break;}
case 119:
#line 824 "dgparse.y"
{ yyval.lex_int = MATCHES; ;
    break;}
case 120:
#line 826 "dgparse.y"
{ yyval.lex_int = STRICTMATCHES; ;
    break;}
case 121:
#line 832 "dgparse.y"
{ yyval.lex_tree = make_exprnode(T_VAR, yyvsp[0].lex_str, 0); ;
    break;}
case 122:
#line 835 "dgparse.y"
{ yyval.lex_tree = make_exprnode(T_METHOD, 
		                     make_exprnode(T_VAR, yyvsp[-2].lex_str, 0), yyvsp[0].lex_str, 0);
		;
    break;}
case 123:
#line 842 "dgparse.y"
{ yyval.lex_tree = make_exprnode(T_INT, yyvsp[0].lex_int); ;
    break;}
case 124:
#line 845 "dgparse.y"
{ yyval.lex_tree = make_exprnode(T_INT, (int)yyvsp[0].lex_float); ;
    break;}
case 125:
#line 848 "dgparse.y"
{ yyval.lex_tree = make_exprnode(T_STRING, yyvsp[0].lex_str); ;
    break;}
case 126:
#line 851 "dgparse.y"
{ yyval.lex_tree = make_exprnode(T_VAR, yyvsp[0].lex_str, 0); ;
    break;}
case 127:
#line 854 "dgparse.y"
{ yyval.lex_tree = make_exprnode(T_INDEX, 
		                     make_exprnode(T_VAR, yyvsp[-3].lex_str, 0), yyvsp[-1].lex_tree); ;
    break;}
case 128:
#line 860 "dgparse.y"
{ yyval.lex_list = 0; ;
    break;}
case 129:
#line 863 "dgparse.y"
{ yyval.lex_list = yyvsp[-1].lex_list; ;
    break;}
case 130:
#line 868 "dgparse.y"
{ yyval.lex_tree = 0; ;
    break;}
case 131:
#line 871 "dgparse.y"
{ yyval.lex_tree = yyvsp[0].lex_tree; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 875 "dgparse.y"

 
yyerror(char * s) 
{
  node_type nt = sstack[nest].nt;
  
  fprintf(stderr, "%s:%d: %s\n", srcfilename,
        	lex_line, s);
  if (nt >= T_IF)
    fprintf(stderr, "...while parsing %s (nest %d) at %s:%d\n",
      nt == T_FUNCTION ? "method definition" :
      nt == T_IF ? "if statement" :
      nt == T_FOR ? "for statement" :
      nt == T_FORALL ? "forall statement" :
      "switch statement",
      nest,
      sstack[nest].filename,
      sstack[nest].lineno);

  pass1error = 1;
}
/*
yywrap(void)
{
  return(1);
}
*/
 
